package de.fhg.iais.kd.gridr.services;

import java.io.File;
import java.io.IOException;
import org.globus.ftp.GridFTPClient;
import org.globus.gram.GramException;
import org.globus.gram.GramJob;
import org.globus.gram.GramJobListener;
import org.globus.gsi.GlobusCredential;
import org.globus.gsi.GlobusCredentialException;
import org.globus.gsi.gssapi.GlobusGSSCredentialImpl;
import org.globus.io.gass.server.GassServer;
import org.globus.io.gass.server.JobOutputListener;
import org.globus.io.gass.server.JobOutputStream;
import org.globus.myproxy.MyProxy;
import org.globus.myproxy.MyProxyException;
import org.globus.rsl.RslAttributes;
import org.ietf.jgss.GSSCredential;
import org.ietf.jgss.GSSException;
import javax.activation.DataHandler;
import javax.activation.FileDataSource;

public class GlobusRWebserviceUtil implements GramJobListener,
// org.globus.exec.client.GramJobListener,
		JobOutputListener {

	// GridRWebservice gridRWS;
	GridFTPClient client;

	GSSCredential credential = null;
	String executionHost;
	int port;
	boolean debug = true;
	boolean threadWait=true;
	DataHandler result = null;
	DataHandler output = null;
	String serviceErrorStr = "Internal Service Error!: ";
	String gridRTmpDir;
    String InputDir=null;
	String remoteHomeDir;
	String localTmpFolder=null;
	String localLibFileGl=null;
	
	/**
	 * 
	 * @param rCodeToExecute 
	 * 							the code which will be executed in the grid
	 * 
	 * @param functionLib 
	 * 							the functions and variables saved in R with save(... asci=TRUE)
	 * 
	 * @param inputdir
	 * 							File(s) which will be copied to the execution host, ie. a gsiftp URI
	 * @param myProxyUsername
	 * 							myproxy myProxyUsername
	 * @param pwd
	 * 							myproxy password
	 * @return result 
	 * 							the result saved in R with save(asci=TUE)
	 * 
	 */
	public DataHandler executeGridR(String rCodeToExecute, String localLibFile, String executionHost, String myProxyHost, String myProxyUsername, String pwd, String inputDir) {

		// Checking input parameters
		/*
		if (inputDir == null || inputDir.length() == 0) { // for testing
			inputDir = "gsiftp://grid-node1:2811/home/malte/testfile.txt";
			//inputDir = "gsiftp://grid6:2811/home/mlohmeyer/testfile.txt";
			if (debug)
				System.err
						.println("GridRWebserviceUtil: inputDir not specified, using dummy "
								+ inputDir);
		}*/
		this.InputDir = inputDir;
		this.executionHost= executionHost;
		localLibFileGl=localLibFile;
		gridRTmpDir = "gridRtmp"+System.currentTimeMillis()+"/";

		try {
			// load credential
			// String myProxyHost = "moss1.man.poznan.pl";
	//		String myProxyHost = "grid-node1.ais.fraunhofer.de";
			try {
			credential = this.getCredential(true, myProxyUsername, pwd, myProxyHost);
			} catch (Exception e) {
				if (debug) {
					System.out.println("GridRWebserviceUtil: MyProxy-Exception: "
							+ e.getMessage());
					e.printStackTrace();
				}//"create a new myproxy with the command \"myproxy-init -l myproxy_username -s myproxy_host\"\n or \"./cog-myproxy -h grid-node1.ais.fraunhofer.de -l mltest put with CoG\""
				return new DataHandler(serviceErrorStr+" "+ e.getMessage() +" for: "+myProxyUsername + " @" + myProxyHost + " pwd: "+ pwd, "text/plain");
			}
	//		executionHost = "grid-node1.ais.fraunhofer.de";
			// host = "193.175.164.2";
			// host = "193.175.164.8";
			// executionHost = "grid6.kd-grid.ais.fraunhofer.de";
			port = 2811;

			String contact = executionHost + ":2119"; // the resource
			// manager
			// contact

			client = new GridFTPClient(executionHost, port);
			client.authenticate(credential);
			remoteHomeDir = client.getCurrentDir() + "/";
			if (debug)
				System.err.println("GridRWebserviceUtil: GridFTP current dir: "
						+ client.getCurrentDir());

			// create tmp working dir
			if (client.exists(gridRTmpDir))
			{
				System.err.println("tmp Folder exists, abort");
				return new DataHandler("tmp Folder exists, abort", "text/plain");
			}
				client.makeDir(gridRTmpDir);
			
			// create file from R code 
			localTmpFolder = "/tmp/"+gridRTmpDir;
			File folder = new File(localTmpFolder);
			folder.mkdir();
			
			
			
			//TESTIG ONLY!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			if(localLibFile=="") 
			{
				localLibFile="/home/malte/testLibs";
			}
			// copy input file(s) to grid
			String remoteDstLibFile = gridRTmpDir + "rCodeLib";
			File sourceLib = new File(localLibFile);
			client.put(sourceLib, remoteDstLibFile, false);
			String remoteDstFile = gridRTmpDir + "rCode";
			File source = new File(rCodeToExecute);
			source.deleteOnExit();
			
			
			client.close();
			//new client, otherwise its impossible to transfer a second file here...
			client = new GridFTPClient(executionHost, port);
			client.authenticate(credential);
			client.put(source, remoteDstFile, false);
			client.close();
			// create GT4 job
			this.createGT4PreWSJob(credential, contact, remoteDstFile,
					gridRTmpDir, inputDir);
			
			// copy result files from grid?


		} catch (Exception e) {
			if (debug) {
				System.out.println("GridRWebserviceUtil: Exception: "
						+ e.getMessage());
				e.printStackTrace();
			}
			return new DataHandler(serviceErrorStr+"Globus: "+e.getMessage(), "text/plain");
		}
		result=new DataHandler("", "text/plain");//dummy DataHandler so that synchronized works
		synchronized (result) {
			try {
				result.wait();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (debug)
			System.out.println("GridRWebserviceUtil: service finished");

		return output;
	}

	/*
	 * get credential from myProxy server or local machine
	 */
	public GSSCredential getCredential(boolean myproxy, String myProxyUsername, String pwd, String myProxyHost) throws MyProxyException,
			GlobusCredentialException, GSSException {

		GSSCredential credential;
		
		if (myproxy) {
			
			if (debug)
				System.err
						.println("GridRWebserviceUtil: if myProxy creation fails try to create a new myproxy with the command \"myproxy-init -l myproxy_username -s myproxy_host\"\n or ./cog-myproxy -h grid-node1.ais.fraunhofer.de -l mltest put with CoG ");

			// create myproxy on myproxy server e.g. by "myproxy-init -l dwtest
			// -s moss1.man.poznan.pl"
			MyProxy myProxy = new MyProxy(myProxyHost, 7512);
			
			int livetime=433000;
			credential = myProxy.get(myProxyUsername, pwd, livetime);//604800
			if (debug)
				System.err.println("GridRWebserviceUtil: myProxy created, livetime: "+credential.getRemainingLifetime());

			
		} else {
			// for using a local credential:
			GlobusCredential gc = GlobusCredential.getDefaultCredential();
			if (debug)
				System.err.println("GridRWebserviceUtil: creating GlobusCredential");
			credential = new GlobusGSSCredentialImpl(gc,
					GlobusGSSCredentialImpl.INITIATE_AND_ACCEPT);

			if (debug)
				System.err.println(gc.getSubject());
			if (debug)
				System.err.println(gc.getIssuer());
			if (debug)
				System.err.println(gc.getProxyType());
			if (debug)
				System.err.println(gc.getIdentity());
			if (debug)
				System.err.println(gc.getTimeLeft());

		}
		return credential;
	}

	private void createGT4PreWSJob(GSSCredential credential, String contact,
			String remoteRCodeFile, String gridRTmpDir, String stageInDir) throws GramException, GSSException, IOException {

		// TODO stageInDir: at the moment just files are possible
		// idea: check if string end with "/",if yes get list of files from dir
		// by gridftp
		// and as much attributes as needed

		// TODO stageOutDir: what is needed from the scenario? full work dir or
		// list of files?
		// note: outPutDir is ok, the local pair is the problem!

		if(debug)
			System.err.println("createGT4PreWSJob");
//		org.globus.gram.Gram gram = new org.globus.gram.Gram();
	//	gram.ping(credential, contact);

		RslAttributes rsl = new RslAttributes();
		// rsl.add("executable", "/bin/ls");
		rsl.add("executable", "/usr/bin/R");
		rsl.add("arguments", "CMD");
		rsl.add("arguments", "BATCH");
		rsl.add("arguments", "--vanilla");
		rsl.add("proxy_timeout", "1");
		// rsl.add("arguments", "<");
		rsl.add("arguments", remoteHomeDir+ remoteRCodeFile);
		// working directory
		rsl.add("directory", gridRTmpDir);
		if(stageInDir!=null)
		{
			String[] remoteLocalPair = { stageInDir, remoteHomeDir + gridRTmpDir };
			rsl.addMulti("file_stage_in", remoteLocalPair);
		}
		GassServer gass = new GassServer(credential, 0);
		
		rsl.add("stdout", gass.getURL() + "/dev/stdout");
		rsl.add("stderr", gass.getURL() + "/dev/stderr");
		JobOutputStream outStream = new JobOutputStream(this);
		gass.registerJobOutputStream("out", outStream);
		gass.registerJobOutputStream("err", outStream);
		GramJob gramJob = new GramJob(credential, rsl.toRSL());
		gramJob.addListener(this);
		gramJob.request(contact);

		if (debug)
			System.err.println("GridRWebserviceUtil: GRAM job ID: "
					+ gramJob.getIDAsString());
		if (debug)
			System.err.println("GridRWebserviceUtil: GRAM job status: "
					+ gramJob.getStatusAsString());

		// gramJob.signal(0);
		if (debug)
			System.err.println("GridRWebserviceUtil: GT4 job created");

		// gramJob.cancel();
		gass.shutdown();
	}

	public void outputChanged(String s) {
		System.err.println("GridRWebserviceUtil: job output: " + s);
		/* process the output here */

	}

	public void outputClosed() {
	}

	private void stageOutGT4PreWSJob() {
		if (debug)
			System.err.println("GridRWebserviceUtil: staging out GT4 job");

		// TODO
	}

	private void readRoutDel() {

		if (debug)
			System.err.println("GridRWebserviceUtil: starting to read R.out");

		FileDataSource f = null;

		try {

			client = new GridFTPClient(executionHost, port);
			client.authenticate(credential);
			// File rOutFile = null;
			File rOutFile = new File("rOutFile.txt");
			this.client.get(gridRTmpDir + "y.dat",
					rOutFile);
			f = new FileDataSource(rOutFile);
			/*
			String rOut = "";

			for (int c; (c = f.read()) != -1;) {
				rOut = rOut + (char) c;
		//		if (debug)
		//			System.out.print((char) c);
			
			}
			result=rOut);
			*/
			output=new DataHandler(f);
			synchronized (result) {
				result.notify();
			}
//			getName of the path of input dir
			if(InputDir!=null) {
				File fil = new File( InputDir);
			
			String nameInputDir =fil.getName(); 
			
//			is output dir a directory or a file?
			if(nameInputDir.charAt(nameInputDir.length()-1)=='/')
				this.client.deleteDir(remoteHomeDir + gridRTmpDir+ nameInputDir);
			else
				this.client.deleteFile(remoteHomeDir + gridRTmpDir+ nameInputDir);
			
			}
		//	System.err.println("remoteHomeDir: "+remoteHomeDir + " gridRTmpDir: "+gridRTmpDir+" nameInputDir dir: "+ nameInputDir);
			
			try{
			//delete remote files
			this.client.deleteFile(remoteHomeDir + gridRTmpDir + "y.dat");
			this.client.deleteFile(remoteHomeDir + gridRTmpDir + "rCode");
			this.client.deleteFile(remoteHomeDir + gridRTmpDir + "rCode.Rout");
			this.client.deleteFile(remoteHomeDir + gridRTmpDir + "rCodeLib");
			
			//delete other transfered remote files & folder
			
			
			this.client.deleteDir(remoteHomeDir + gridRTmpDir);
			this.client.close();
			
			
			//delete local tmp files
			
			File rCodeLib= new File(localLibFileGl);
			rCodeLib.delete();
			
			File folder = new File(localTmpFolder);
			folder.delete();
			}
			catch(Exception e)
			{
				e.printStackTrace();
				System.err.println("Cannot delete some of the files");
			}

			
		
		} catch (Exception e) {
			e.printStackTrace();
			new DataHandler(serviceErrorStr+": "+ e.getMessage(), "text/plain");
		} 
	}

	public void statusChanged(GramJob arg0) {

		GramJob gramJob = (GramJob) arg0;

		if (debug)
			System.err.println("GridRWebserviceUtil: GRAM job "
					+ gramJob.getIDAsString() + " status changed to: "
					+ gramJob.getStatusAsString());

		if (gramJob.getStatus() == gramJob.STATUS_DONE) {
			// TODO exit ... ;
			this.stageOutGT4PreWSJob();

			if (debug)
				System.err
						.println("GridRWebserviceUtil: GRAM job DONE, trying to exit");

			readRoutDel();

			gramJob.removeListener(this);
		} else if (gramJob.getStatus() == gramJob.STATUS_FAILED) {
			if (debug)
				System.err
						.println("GridRWebserviceUtil: GRAM job FAILED, trying to exit");
			if (debug)
				System.err.println("GridRWebserviceUtil: GRAM job ERROR: "
						+ GramException.getMessage(gramJob.getError()));

			output= new DataHandler("GRAM job ERROR: "
					+ GramException.getMessage(gramJob.getError()), "text/plain");
			synchronized (result) {
				result.notify();
			}
			gramJob.removeListener(this);
			
			
		}
	}
}
